//LEDdisp.java - a 3 digit display made of 7 segment LED characters.
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;
import javax.swing.border.*;

public class LEDdisp {
   JPanel display;
   private MyMines myMines;
   private URL codeBase;
   ImageIcon LEDminus, LED[];
   dispButton left, mid, right;

   public LEDdisp (final MyMines myMines) {
      this.myMines = myMines;
      display = new JPanel( new GridLayout(1,3,0,0) );
      LED = new ImageIcon[10];
      codeBase = myMines.getCodeBase();
      LEDminus = new ImageIcon(myMines.getImage(codeBase, "LEDminus.gif"));
      LED[0] = new ImageIcon(myMines.getImage(codeBase, "LED0.gif"));
      LED[1] = new ImageIcon(myMines.getImage(codeBase, "LED1.gif"));
      LED[2] = new ImageIcon(myMines.getImage(codeBase, "LED2.gif"));
      LED[3] = new ImageIcon(myMines.getImage(codeBase, "LED3.gif"));
      LED[4] = new ImageIcon(myMines.getImage(codeBase, "LED4.gif"));
      LED[5] = new ImageIcon(myMines.getImage(codeBase, "LED5.gif"));
      LED[6] = new ImageIcon(myMines.getImage(codeBase, "LED6.gif"));
      LED[7] = new ImageIcon(myMines.getImage(codeBase, "LED7.gif"));
      LED[8] = new ImageIcon(myMines.getImage(codeBase, "LED8.gif"));
      LED[9] = new ImageIcon(myMines.getImage(codeBase, "LED9.gif"));
      left = new dispButton();
      mid = new dispButton();
      right = new dispButton();
      display.add(left);
      display.add(mid);
      display.add(right);
   }

   public void write(int count) {
      int leftDigit, midDigit, rightDigit;
      boolean negative = false;

      if(count < -99) {
         negative = true;
         count = 99;
      } else if(count < 0) {
         negative = true;
         count = -count;
      } else if(count > 999) {
         count = 999;
      }

      leftDigit = count/100;
      midDigit = (count % 100)/10;
      rightDigit = count % 10;
      if(negative) leftDigit = -1;

      left.setValue(leftDigit);
      mid.setValue(midDigit);
      right.setValue(rightDigit);
   }

   public JPanel getJPanel() { return display; }

   private class dispButton extends JButton {
      Insets zeroMargin;
      int value = 0;
      Border emptyBorder;

      dispButton() {
         super(LED[0]);
         zeroMargin = new Insets(0,0,0,0);
         setMargin(zeroMargin);
         emptyBorder = BorderFactory.createEmptyBorder(0,0,0,0);
         setBorder(emptyBorder);
      }

      public void setValue(int val) {
         value = val;
         if(value > 9) value = 9;

         if(value < 0) setIcon(LEDminus);
         else setIcon(LED[value]);
      }

      public int getValue() { return value; }
   }//End dispButton;
}//End LEDdisp.
