//Smiley.java - part of Bill's Java Minesweeper
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;

public class Smiley extends JButton {
   private ImageIcon smile;
   private ImageIcon frown;
   private ImageIcon shades;
   private ImageIcon worry;
   private MyMines myMines;
   private URL codeBase;

   Smiley(final MyMines myMines) {
      super();
      this.myMines = myMines;
      codeBase = myMines.getCodeBase();
      smile = new ImageIcon(myMines.getImage(codeBase, "smile.gif"));      //During a game.
      frown = new ImageIcon(myMines.getImage(codeBase, "frown.gif"));      //Lost the game.
      shades = new ImageIcon(myMines.getImage(codeBase, "shades.gif"));    //Won the game.
      worry = new ImageIcon(myMines.getImage(codeBase, "worry.gif"));      //Can't do that...

      setMargin(new Insets(0,0,0,0));
      setSmile();
      addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            myMines.setupNewGame(false);
         }
      });
   }

   void setSmile() { setIcon(smile); }
   void setFrown() { setIcon(frown); }
   void setShades() { setIcon(shades); }
   void setWorry() { setIcon(worry); }

}//End Smiley.
